<!-- Copyright (c) Vincent Dardel, <vindarez@mailz.org>,  Abelujo Developers-->
<!-- See the COPYRIGHT file at the top-level directory of this distribution-->
<!-- Abelujo is free software: you can redistribute it and/or modify-->
<!-- it under the terms of the GNU Affero General Public License as published by-->
<!-- the Free Software Foundation, either version 3 of the License, or-->
<!-- (at your option) any later version.-->
<!-- Abelujo is distributed in the hope that it will be useful,-->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of-->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the-->
<!-- GNU Affero General Public License for more details.-->
<!-- You should have received a copy of the GNU Affero General Public License-->
<!-- along with Abelujo.  If not, see <http://www.gnu.org/licenses/>.-->

{% extends "base.html" %}
{% block pagetitle %}
{{ page_title }}
{% endblock pagetitle%}
{% block content %}
{% load i18n %}
{% load staticfiles %}
{% load bootstrap3 %}
{% bootstrap_css %}
{% bootstrap_javascript %}
{% load ngfilter %}
{% load humanize %}
{% get_current_language as LANGUAGE_CODE %}

<!---->
<!-- No Angular nor Vue, uses card.js and abelujo-js.js-->
<!---->
<div class="row">
  <div class="col-lg-12">
    <ul class="nav nav-tabs">
      <li role="presentation" class="active"><a href="#">{% trans "Card details" %}</a>
      </li>
      <li role="presentation"><a href="{% url 'card_history' object.pk %}">{% trans "History" %}</a>
      </li>
    </ul>
  </div>
</div>
<div class="row">
  <div class="col-lg-3">
    {% if  user.is_staff %}
    <div class="btn-group">
      <a href="{% url 'card_edit' object.pk %}"
          title="{% trans 'Edit the card' %}"
          class="btn btn-default">
        {% trans "Edit" %}
      </a>
      <a href="{% url 'card_places_add' object.pk %}"
          title="{% trans 'Add to places' %}"
          class="btn btn-default">
        {% trans "Add..." %}
      </a>
      <!-- a.btn.btn-default(href="{% url 'card_move' object.pk %}") {% trans 'Move…' %}-->
      <a href="/{{ LANGUAGE_CODE }}/databasesearch/card/{{ object.pk }}"
          title="{% trans 'Edit the card'  %}"
          class="btn btn-default">
        Admin
      </a>
    </div>
    {% endif %}

  </div>
  <div class="col-lg-7">
    {% if  user.is_staff %}
    <div>
      <div class="btn-group">
        <a href="#"
            title="{% trans "Add 1 copy to the default place" %}"
            onclick="card_add_one_to_default_place({{ object.pk }})"
            class="btn btn-default">
          <i class="glyphicon glyphicon-plus">
            1
          </i>
        </a>
        <a href="#" title="{% trans "Remove 1 copy to the default place" %}"
            onclick="card_remove_one_from_default_place({{ object.pk }})"
            class="btn btn-default">
          <i class="glyphicon glyphicon-minus">
            1
          </i>
        </a>
      </div>

      <div style="margin-left: 1em"
          class="btn-group">
        <a href="#"
            title="{% trans "Remember to command this card. Add it to the list for later." %}"
            onclick="card_command({{ object.pk }})"
            class="btn btn-warning">
          <i class="glyphicon glyphicon-shopping-cart"></i>
          <span>&nbsp; x
            <span id="nb_to_command_{{ object.pk }}">
              {{ object.quantity_to_command }}
            </span>
          </span>
        </a>
      </div>

      <div style="margin-left: 1em"
          class="btn-group">
        {% if  object.is_catalogue_selection %}
        <a id="heart-{{ object.pk }}"
            href=""
            title="{% trans "Select this card for the online catalogue special selection." %}"
            onclick="card_catalogue_select({{ object.pk }})"
            style="background-color: pink"
            class="btn btn-default">
          <i class="glyphicon glyphicon-heart"></i>
        </a>
        {% else %}
        <a id="heart-{{ object.pk }}"
            href=""
            title="{% trans "Select this card for the online catalogue special selection." %}"
            onclick="card_catalogue_select({{ object.pk }})"
            class="btn btn-default">
          <i class="glyphicon glyphicon-heart"></i>
        </a>
        {% endif %}
        {% if  feature_exclude_for_website %}
	{% if  object.is_excluded_for_website %}
        <a id="exclude-{{ object.pk }}"
            href=""
	    title="{% trans "Exclude this card from the online catalogue." %}"
	    onclick="card_catalogue_exclude({{ object.pk }})" style="background-color: pink" class="btn btn-default">
          <i class="glyphicon glyphicon-eye-close"></i>
        </a>
        {% else %}
        <a id="exclude-{{ object.pk }}"
            href=""
	    title="{% trans "Exclude this card from the online catalogue." %}"
	    onclick="card_catalogue_exclude({{ object.pk }})"
            class="btn btn-default">
          <i class="glyphicon glyphicon-eye-close"></i>
        </a>
	{% endif %}
	{% endif %}

        <!-- WIP reservation button. Enable with feature flag in settings.-->
	{% if  feature_show_reservation_button %}
        <button type="button" data-toggle="modal"
            data-target="#reserveModal"
	    title="Réserver pour un client"
	    onclick="focus_input()"
            class="btn btn-default">
          <i class="glyphicon glyphicon-user"></i>
          <span>&nbsp; x
            <span id="nb_to_command">
              {{ object.quantity_clients_reserved }}
            </span>
          </span>
        </button>
	{% endif %}

      </div>
    </div>
    {% endif %}

  </div>
</div>

<div class="row">
  <div class="col-lg-3">
    <div style="margin: 1em 0 0 1px;" class="row">

      <!-- Click to enlarge image. -->
      <a data-toggle="modal"
          data-target="#enlargeImageModal"
	  title="{% trans 'Enlarge image' %}">
        <img ng-src="{{ object.img }}" style="max-width: 200px" class="img-responsive mouse-pointer"/>
      </a>

    </div>
    <div style="margin-left: 1px;" class="row">
      <h4>
        {{ object.price_fmt }}
	{% if object.selling_price %}

        <div>
          {% trans "Selling price" %}: {{ object.selling_price }}
        </div>
	{% endif %}

	{% if  object.vat1 %}
        <span
	  title="{{ object.vat1 }}% of {{ object.price }} is {{ object.check_vat.0 }}. Actual tax is {{ object.check_vat.1 }}%">
          &nbsp; {% trans "vat" %} ({{ object.price_excl_vat }}, {{ object.vat1 }}%)
        </span>
	{% endif %}
	{% if  object.vat %}
        <span> {% trans "vat" %} {{ object.vat }}% </span>
	{% endif %}
      </h4>

      <table class="table table-condensed table-bordered">
        <tbody>
          <tr>
            <td>{% trans "isbn" %}</td>
            <td>{{ object.isbn }}</td>
          </tr>
	  {% if  object.is_unavailable %}
          <tr class="my-yellow-bg">
            <td>Disponibilité</td>
            <td>{% trans "Not available" %}</td>
          </tr>
          {% else %}
	  {% if  object.availability == 1 %}
          <tr>
            <td>Disponibilité</td>
            <td>{{ object.availability_fmt }}</td>
          </tr>
          {% else %}
          <tr class="my-yellow-bg">
            <td>Disponibilité</td>
            <td>{{ object.availability_fmt }}</td>
          </tr>
	  {% endif %}
	  {% endif %}

	  {% if  object.date_publication %}
          <tr>
            <td>{% trans "Publication date" %}</td>
            <td>{{ object.date_publication }}</td>
          </tr>{% elif  object.year_published %}
          <tr>
            <td>{% trans "Publication date" %}</td>
            <td>{{ object.year_published }}</td>
          </tr>
	  {% endif %}

          <tr>
            <td>
              {# Translators: format like pocket or big (livre de poche) #}
              {% trans "format" %}
            </td>
            <td>
	      {% if  object.fmt %}<span>{{ object.fmt }}</span>
	      {% endif %}
	      {% if  object %}
              <span
	          title="{% trans "width" %} {% trans "height" %} {% trans "thickness" %}">({{ object.width }} x {{ object.height }} x {{ object.thickness }})
              </span>
	      {% endif %}
            </td>
          </tr>
	  {% if  object.weight %}

          <tr>
            <td>{% trans "Weight" %}</td>
            <td>{{ object.get_weight_repr }}</td>
          </tr>
	  {% endif %}

          <tr>
            <td>{% trans "Présentation éditeur" %}</td>
            <td>{{ object.presedit_name }}</td>
          </tr>

          <tr>
            <td>{% trans "source" %}: </td>
            <td>
	      {% if  object.data_source %}
	      {% if  object.data_source.lower == "dilicom" %}<span>{{ object.data_source }}</span>
              {% else %}
              <a target="_blank" href="{{ object.details_url }}">{{ object.data_source }}
              </a>
	      {% endif %}
	      {% endif %}
            </td>
          </tr>

          <tr>
            <td><span><a target="_blank" href="https://duckduckgo.com/?q={{object.title}}+{{object.display_authors}}">{% trans "Web search" %}<span style="padding-left: 3px;" class="glyphicon glyphicon-share-alt"></span>
            </a></span>
            </td>
          </tr>

        </tbody>
      </table>
    </div>
  </div>

  <div class="col-lg-9">
    <h3>{{ object.title }}</h3>
    <h4>
      {% if  object.card_type.name != "book" %}
      <span style="margin-right: 1em"
	  onclick="search_stock('type:{{ object.card_type.pk }}')"
          class="label label-default mouse-pointer">{{ object.card_type.name }}</span>
      {% endif %}
      {% if  object.lang %}
      <i style="margin-right: 1em" class="glyphicon glyphicon-comment">
	<span style="margin-left: 5px"
	    onclick="search_stock('lang:{{ object.lang }}')"
	    title="Chercher dans le stock" class="mouse-pointer">{{ object.lang }}</span></i>
      {% endif %}<a
	             onclick="search_authors_stock()" href="" style="color: #333333; text-decoration: underline" data-authors="{{ object.display_authors }}" id="authors"
	             title="Chercher dans le stock">{{ object.display_authors }}
      </a>
    </h4>
    <div class="col-lg-8">
      <table class="table">
        <tbody>
          <tr>
            <td>{% trans "Publishers" %}</td>
            <td>{% for pub in object.get_publishers %}
              <div>
	        <a id="publisher_{{ forloop_counter0 }}" href=""
	            onclick="search_publisher_stock()" data-publisher="{{ pub.name }}"
	            title="Chercher dans le stock">{{ pub.name }}
                </a>
              </div>{% endfor %}
            </td>
          </tr>
	  {% if  not object.distributor %}
          <tr>
            <td>{% trans "Supplier" %}</td>
            <td>
              <select id="distributor" onchange="update_distributor()">
                <option value="0" selected="selected">
	        </option>{% for dist in distributors %}
                <option value="{{ dist.pk }}">{{ dist.name }}</option>{% endfor %}
              </select>
            </td>
          </tr>{% else %}
          <tr>
            <td>{% trans "Supplier" %}</td>
            <td>{% for dist in object.get_distributor %}<span>
	      <a id="supplier" href=""
	          onclick="search_supplier_stock()" data-supplier_id="{{ dist.id }}"
	          title="Chercher dans le stock">{{ dist.repr }}
              </a>
	    </span>
	    <span>
	      {% if dist.gln %} ({{dist.gln}})
	      {% endif %}</span>{% endfor %}
            </td>
          </tr>
	  {% endif %}
	  {% if  object.get_distributor and object.distributor.dilicom_enabled %}
          <tr>
            <td>{% trans "Commande via Dilicom ?" %}</td>
            <td>{{ object.distributor.is_comm_via_dilicom }}</td>
          </tr>
	  {% endif %}
          <tr>
            <td>{% trans "Collection" %}</td>
            <td>
	      {% if  object.collection %}{{ object.collection }}

	      {% endif %}
            </td>
          </tr>
          <tr>
            <td>{% trans "Shelf" %}: </td>
            <td id="shelf-name" style="display: none">
	      {% if  object.shelf %}{{ object.shelf }}

	      {% endif %}
            </td>
            <td id="shelf-id" style="display: none" data-shelf_id="{{ object.shelf.pk }}">
	      {% if  object.shelf %}<span>{{ object.shelf.pk }}</span>
	      {% endif %}
            </td>
            <td id="shelf-select-td">
              <select id="shelf-select" name="shelves"></select>
              <span>
                <a href=""
	            onclick="search_shelf_stock()"
                    title="Chercher dans le stock">
                  <i class="glyphicon glyphicon-search"> </i>
                </a>
              </span>
            </td>
          </tr>
	  {% if  object.theme %}
          <tr>
            <td>{% trans "Theme" %}: </td>
            <td
	        title="CLIL code: {{ object.theme }}">
	      {% if  object.parent_theme_name %}{{ object.parent_theme_name }} /

	      {% endif %}
	      {% if  object.theme %}{{ object.theme_name }}

	      {% endif %}
            </td>
          </tr>
	  {% endif %}

          <tr class="
	             {% if object.quantity > 0 %} active {% elif object.quantity < 0 %} danger
	             {% endif %}">
            <td>{% trans "In stock" %}</td>
            <td id="in_stock">
	      <span>{{ object.quantity_compute }}</span>
	      {% if  object.quantity_clients_reserved %}<span>&nbsp; ({% trans "reserved" %}: &nbsp;</span>
	      <span id="reservation">{{ object.quantity_clients_reserved }}
	        {% if  has_one_reservation %}<span>&nbsp; {{ reservations.0.client.repr }}</span>
	        {% endif %}</span>
	      <span>)</span>
	      {% endif %}
            </td>
          </tr>


	  {% if  has_many_places %}
          <tr>
            <td>{% trans "Presente in" %}</td>
	    {% if  not object.quantity %}
            <td>---</td>
            {% else %}
            <td>
              <table class="table table-condensed">{% for name_qty in places_quantities %}
                <tr>
                  <td id="{{ name_qty.2 }}">{{ name_qty.0 }} </td>
                  <td id="{{ name_qty.2}}_quantity">{{ name_qty.1 }}</td>
                </tr>{% endfor %}
              </table>
            </td>
	    {% endif %}
          </tr>
	  {% endif %}

          <tr>
            <td>{% trans "Boxes" %}</td>
	    {% if  not quantity_boxes %}
            <td>---</td>
	    {% else %}
            <td>
              <table class="table table-condensed">{% for tup in quantity_boxes %}
                <tr>
                  <td>
	            <a href="{% url 'box_view' tup.1 %}">{{ tup.2 }}
                    </a>
                  </td>
                  <td>{{ tup.0 }}</td>
                </tr>{% endfor %}
              </table>
            </td>
	    {% endif %}
          </tr>

          {% if FEATURE_INSTITUTIONS %}
          <tr class="{% if object.institutions %} active {% endif %}">
            <td>{% trans "Institutions" %}</td>
            <td id="in_institutions">
              {{ object.institutions | length }}
              {% if object.institutions %}
              <span>: </span>

	      {% for it in object.institutions %}
	      <span id="institution">{{ it.client }}
                {% if not forloop.last %}
                <span>,</span>
                {% endif %}
              </span>
              {% endfor %}

              {% else %}
              <td>---</td>
              {% endif %}
            </td>
          </tr>
          {% endif %}

          <tr>
            <td>{% trans "Minimal qty" %}</td>
            <td>{{ object.threshold }}</td>
          </tr>
          <tr class="
	             {% if object.quantity_deposits > 0 %} active {% elif object.quantity_deposits < 0 %} danger
	             {% endif %}">
            <td>{% trans "In deposits" %}</td>
            <td>{{ object.quantity_deposits }}</td>
          </tr>
	  {% if  object.quantity_deposits %}
          <tr>
            <td>{% trans "Deposits" %}</td>
            <td>{% for dep_tup in object.deposits %}
              <div>
	        <a href="/deposits/{{ dep_tup.1 }}">{{ dep_tup.0 }}
                </a>
              </div>{% endfor %}
	      {% if  not object.deposits and not object.quantity %}<span>--- &nbsp;<a href="{% url 'deposits_new' %}">({% trans "Create" %})
              </a>
	      </span>
	      {% endif %}
            </td>
          </tr>
	  {% endif %}
        </tbody>
      </table>
      <div>
	{% if  object.summary %}
        <hr/>
        <h4>
	  <span style="padding-right: 1em;" class="glyphicon glyphicon-align-left">
	  </span>
	  <span>{% trans "Summary" %}</span>
        </h4>
        <div style="padding-left: 1em">{{ object.summary }}</div>
	{% else %}
        <div>
	</div>
	{% endif %}
      </div>
      <div>
        <h4>{% trans "Comment" %} </h4>
        <div>
	  <a href="{% url 'admin:search_card_change' object.pk %}" target="_blank">{% trans "edit" %}
          </a>
        </div>
	<em class="my-border">{{ object.comment }}</em>
      </div>
    </div>

    <div class="col-lg-4">
      <table class="table table-condensed">
        <tbody>
          <tr class="
	             {% if object.alert_set.count %} danger
	             {% endif %}">
            <td>{% trans "Alerts" %}</td>
            <td>{{ object.alert_set.count }}</td>
          </tr>
          <tr>
            <td>{% trans "Card creation" %}</td>
            <td>{{ object.created }}</td>
          </tr>
          <tr>
            <td>{% trans "Last entry" %}</td>
            <td>{{ last_entry.created }}
            </td>
          </tr>
          <tr>
            <td>{% trans "Sells since the last entry" %}</td>
            <td>{{ sold_since_last_entry }}</td>
          </tr>
          <tr>
            <td>{% trans "Last sell" %}</td>
            <td>
              {% if last_soldcard_date %}
              <span style="box-shadow: 0 -.5rem 0 0 {{ age_dict.color }} inset">

	      <a href="{% url 'history_sells_day' last_soldcard_date_short %}" target="_blank" title=''>
                {{ last_soldcard_date | date:"d N Y"}}
              </a>
              </span>
              {% endif %}
            </td>
          </tr>
          <tr>
            <td>{% trans "Total sold" %}</td>
            <td>{{ total_copies_sold }}</td>
          </tr>
          <tr>
            <td>{% trans "last months" %} (12)</td>
            <td>{{ total_sold_last_12_months }}</td>
          </tr>
          <tr>
            <td>{% trans "last months" %} (3)</td>
            <td>{{ total_sold_last_3_months }}</td>
          </tr>
          <tr>
            <td>{% trans "Pending commands" %}</td>
            <td>
	      {% if  not pending_commands %}
              <div>0</div>
	      {% else %}
              <ul>{% for cmd in pending_commands %}
                <li>x{{ cmd.qty }} -
                  <a href="{{ cmd.command.get_absolute_url }}">{{ cmd.command.title }}
                  </a> -
                  {{ cmd.command.created }}
                </li>{% endfor %}
              </ul>
	      {% endif %}
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</div>

<!-- we'll use the modal shortly !-->
<script type="text/ng-template" id="commandModal.html">
  <div class="modal-header">
    <h3 class="modal-title">{% trans "Command" %}</h3>
    <div>{% trans "The cards are grouped by supplier. Please check the list and confirm." %}</div>
  </div>
  <div class="modal-body">
    <div ng-repeat="card in cards">
      <h4>{% trans "Supplier" %}: {{ 'distributor.name' | ng }}</h4>
      <div ng-repeat="card in cards">
        <div>{{'card.title'|ng}}</div>
      </div>
    </div>
  </div>
</script>

<div id="reserveModal" class="modal">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">{% trans "Réserver" %}</h4>
        <button type="button" data-dismiss="modal" class="close">
	</button>
      </div>
      <div class="modal-body">
        <div>{% trans "Si ce livre n'est pas en stock il sera ajouté à la liste de commandes." %}</div>
        <div>{% trans "S'il est en rayon, cliquer sur OK veut dire que vous l'avez mis de côté pour le client." %}</div>
        <form>
          <div class="form-group">
            <label>Client</label>

            <input id="clients-input" autofocus="autofocus" type="text" list="clients-select" onkeydown="if (event.keyCode == 13) validate_reservation()" class="form-control"/>
            <datalist id="clients-select">{% for client in clients %}
              <option value="{{ client.ascii_repr }}" id="{{ client.id }}">
	      </option>{% endfor %}
            </datalist>
	    <small class="form-text text-muted">{% trans "Cherchez sans accents" %}</small>
          </div>
          <div class="form-group">
            <label>{% trans "Quantity" %}</label>

            <input id="input-quantity" type="number" default="1" max="99" min="1" value="1" onkeydown="if (event.keyCode == 13) validate_reservation()" class="form-control"/>
          </div>
        </form>
        <button type="button"
	    onclick="validate_reservation()" class="btn btn-success">OK</button>
	<br/>
	{% if  reservations %}
        <h5>{% trans "Ces clients ont réservé cette notice" %}:</h5>
        <table class="table table-condensed">
          {% for resa in reservations %}
          <tr id="#resa-{{ resa.client.id }}">
            <td>
              <h4>
	        <a href="{{ resa.client.get_absolute_url }}" target="_blank">{{ resa.client.repr }} &nbsp; {{ resa.client.url }}
                  <i class="glyphicon glyphicon-share">
	          </i>
                </a>
              </h4>
            </td>
            <td>
	      {% if  resa.client.mobilephone %}<span>{{ resa.client.mobilephone }} 
              <i class="glyphicon glyphicon-phone"></i>
	      </span>
	      {% endif %}
            </td>
            <td>
	      <span>x{{ resa.nb }}</span>
            </td>
            <td>
              <button type="button"
	          onclick="cancel_reservation({{ resa.client.id }})"
                  name="cancel-reservation"
                  alt="Cancel reservation">
                <i class="glyphicon glyphicon-remove"></i>
              </button>
            </td>
          </tr>
          {% endfor %}
        </table>
	{% endif %}
      </div>
    </div>
  </div>
</div>

<!-- enlargeImageModal ci-dessous: -->
<div id="enlargeImageModal" class="modal">
  {% include "search/modale_enlarge_image.html" %}
</div>

<!-- important to run this last, so CSS selectors select something.-->
<script type="text/javascript" src="{% static 'search/js/card.js' %}"> </script>

{% endblock content %}
